---
name: ci
on:
  push:
    branches-ignore:
      - master
jobs:
  lint:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v2
      - uses: actions/setup-python@v2
      - name: Install linters
        run: |
          python -m pip install --upgrade pip
          pip install flake8 flake8-black yamllint
      - name: Lint with flake8
        run: |
          flake8 .
      - name: Lint with yamllint
        run: |
          yamllint .
  test:
    runs-on: ubuntu-latest
    needs: lint
    steps:
      - name: Checkout
        uses: actions/checkout@v2

      - name: Docker Build
        uses: docker/build-push-action@v2
        with:
          context: .
          tags: shm013/certbot-dns-freenom:latest
          load: true
          build-args: |
            ARCH=amd64
            CERTBOT_VERSION=1.16.0

      - name: Prepare Test
        run: |
          echo "certbot_dns_freenom:dns_freenom_username = \
          ${{ secrets.FREENOM_USERNAME }}
          certbot_dns_freenom:dns_freenom_password = \
          ${{ secrets.FREENOM_PASSWORD }}" > credentials.ini
          chmod 600 credentials.ini

      - name: Perform Test
        run: "docker run
        --pull never \
        -v ${PWD}/credentials.ini:/credentials.ini \
        -v /etc/letsencrypt:/etc/letsencrypt \
        -v /var/lib/letsencrypt:/var/lib/letsencrypt \
        -v /var/log/letsencrypt:/var/log/letsencrypt \
        shm013/certbot-dns-freenom:latest \
        certonly \
        -a certbot-dns-freenom:dns-freenom \
        --certbot-dns-freenom:dns-freenom-credentials /credentials.ini \
        --certbot-dns-freenom:dns-freenom-propagation-seconds 300 \
        -d '*.${{ secrets.FREENOM_DOMAIN }}' \
        -m ${{ secrets.FREENOM_USERNAME }} \
        --server https://acme-staging-v02.api.letsencrypt.org/directory \
        --agree-tos \
        -n"

      - name: Test cert files
        run: |
          sudo test -f /etc/letsencrypt/live/\
          ${{ secrets.FREENOM_DOMAIN }}/fullchain.pem || \
          ( echo "Error - fullchain.pem not exists"; return 1 )
